/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 4 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"

/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

/**
 * Thrift parser.
 *
 * This parser is used on a thrift definition file.
 *
 */

#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS
#endif
#ifndef __STDC_FORMAT_MACROS
#define __STDC_FORMAT_MACROS
#endif
#include <stdio.h>
#include <string.h>
#ifndef _MSC_VER
#include <inttypes.h>
#else
#include <stdint.h>
#endif
#include <limits.h>
#ifdef _MSC_VER
#include "thrift/windows/config.h"
#endif
#include "thrift/main.h"
#include "thrift/common.h"
#include "thrift/globals.h"
#include "thrift/parse/t_program.h"
#include "thrift/parse/t_scope.h"

#ifdef _MSC_VER
//warning C4065: switch statement contains 'default' but no 'case' labels
#pragma warning(disable:4065)
#endif

/**
 * This global variable is used for automatic numbering of field indices etc.
 * when parsing the members of a struct. Field values are automatically
 * assigned starting from -1 and working their way down.
 */
int y_field_val = -1;
/**
 * This global variable is used for automatic numbering of enum values.
 * y_enum_val is the last value assigned; the next auto-assigned value will be
 * y_enum_val+1, and then it continues working upwards.  Explicitly specified
 * enum values reset y_enum_val to that value.
 */
int32_t y_enum_val = -1;
int g_arglist = 0;
const int struct_is_struct = 0;
const int struct_is_union = 1;


#line 145 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "thrifty.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_tok_identifier = 3,             /* tok_identifier  */
  YYSYMBOL_tok_literal = 4,                /* tok_literal  */
  YYSYMBOL_tok_doctext = 5,                /* tok_doctext  */
  YYSYMBOL_tok_int_constant = 6,           /* tok_int_constant  */
  YYSYMBOL_tok_dub_constant = 7,           /* tok_dub_constant  */
  YYSYMBOL_tok_include = 8,                /* tok_include  */
  YYSYMBOL_tok_namespace = 9,              /* tok_namespace  */
  YYSYMBOL_tok_cpp_include = 10,           /* tok_cpp_include  */
  YYSYMBOL_tok_cpp_type = 11,              /* tok_cpp_type  */
  YYSYMBOL_tok_xsd_all = 12,               /* tok_xsd_all  */
  YYSYMBOL_tok_xsd_optional = 13,          /* tok_xsd_optional  */
  YYSYMBOL_tok_xsd_nillable = 14,          /* tok_xsd_nillable  */
  YYSYMBOL_tok_xsd_attrs = 15,             /* tok_xsd_attrs  */
  YYSYMBOL_tok_void = 16,                  /* tok_void  */
  YYSYMBOL_tok_bool = 17,                  /* tok_bool  */
  YYSYMBOL_tok_string = 18,                /* tok_string  */
  YYSYMBOL_tok_binary = 19,                /* tok_binary  */
  YYSYMBOL_tok_slist = 20,                 /* tok_slist  */
  YYSYMBOL_tok_senum = 21,                 /* tok_senum  */
  YYSYMBOL_tok_i8 = 22,                    /* tok_i8  */
  YYSYMBOL_tok_i16 = 23,                   /* tok_i16  */
  YYSYMBOL_tok_i32 = 24,                   /* tok_i32  */
  YYSYMBOL_tok_i64 = 25,                   /* tok_i64  */
  YYSYMBOL_tok_double = 26,                /* tok_double  */
  YYSYMBOL_tok_map = 27,                   /* tok_map  */
  YYSYMBOL_tok_list = 28,                  /* tok_list  */
  YYSYMBOL_tok_set = 29,                   /* tok_set  */
  YYSYMBOL_tok_oneway = 30,                /* tok_oneway  */
  YYSYMBOL_tok_typedef = 31,               /* tok_typedef  */
  YYSYMBOL_tok_struct = 32,                /* tok_struct  */
  YYSYMBOL_tok_xception = 33,              /* tok_xception  */
  YYSYMBOL_tok_throws = 34,                /* tok_throws  */
  YYSYMBOL_tok_extends = 35,               /* tok_extends  */
  YYSYMBOL_tok_service = 36,               /* tok_service  */
  YYSYMBOL_tok_enum = 37,                  /* tok_enum  */
  YYSYMBOL_tok_const = 38,                 /* tok_const  */
  YYSYMBOL_tok_required = 39,              /* tok_required  */
  YYSYMBOL_tok_optional = 40,              /* tok_optional  */
  YYSYMBOL_tok_union = 41,                 /* tok_union  */
  YYSYMBOL_tok_reference = 42,             /* tok_reference  */
  YYSYMBOL_43_ = 43,                       /* '*'  */
  YYSYMBOL_44_ = 44,                       /* ','  */
  YYSYMBOL_45_ = 45,                       /* ';'  */
  YYSYMBOL_46_ = 46,                       /* '{'  */
  YYSYMBOL_47_ = 47,                       /* '}'  */
  YYSYMBOL_48_ = 48,                       /* '='  */
  YYSYMBOL_49_ = 49,                       /* '['  */
  YYSYMBOL_50_ = 50,                       /* ']'  */
  YYSYMBOL_51_ = 51,                       /* ':'  */
  YYSYMBOL_52_ = 52,                       /* '('  */
  YYSYMBOL_53_ = 53,                       /* ')'  */
  YYSYMBOL_54_ = 54,                       /* '<'  */
  YYSYMBOL_55_ = 55,                       /* '>'  */
  YYSYMBOL_YYACCEPT = 56,                  /* $accept  */
  YYSYMBOL_Program = 57,                   /* Program  */
  YYSYMBOL_CaptureDocText = 58,            /* CaptureDocText  */
  YYSYMBOL_DestroyDocText = 59,            /* DestroyDocText  */
  YYSYMBOL_HeaderList = 60,                /* HeaderList  */
  YYSYMBOL_Header = 61,                    /* Header  */
  YYSYMBOL_Include = 62,                   /* Include  */
  YYSYMBOL_DefinitionList = 63,            /* DefinitionList  */
  YYSYMBOL_Definition = 64,                /* Definition  */
  YYSYMBOL_TypeDefinition = 65,            /* TypeDefinition  */
  YYSYMBOL_CommaOrSemicolonOptional = 66,  /* CommaOrSemicolonOptional  */
  YYSYMBOL_Typedef = 67,                   /* Typedef  */
  YYSYMBOL_Enum = 68,                      /* Enum  */
  YYSYMBOL_EnumDefList = 69,               /* EnumDefList  */
  YYSYMBOL_EnumDef = 70,                   /* EnumDef  */
  YYSYMBOL_EnumValue = 71,                 /* EnumValue  */
  YYSYMBOL_Senum = 72,                     /* Senum  */
  YYSYMBOL_SenumDefList = 73,              /* SenumDefList  */
  YYSYMBOL_SenumDef = 74,                  /* SenumDef  */
  YYSYMBOL_Const = 75,                     /* Const  */
  YYSYMBOL_ConstValue = 76,                /* ConstValue  */
  YYSYMBOL_ConstList = 77,                 /* ConstList  */
  YYSYMBOL_ConstListContents = 78,         /* ConstListContents  */
  YYSYMBOL_ConstMap = 79,                  /* ConstMap  */
  YYSYMBOL_ConstMapContents = 80,          /* ConstMapContents  */
  YYSYMBOL_StructHead = 81,                /* StructHead  */
  YYSYMBOL_Struct = 82,                    /* Struct  */
  YYSYMBOL_XsdAll = 83,                    /* XsdAll  */
  YYSYMBOL_XsdOptional = 84,               /* XsdOptional  */
  YYSYMBOL_XsdNillable = 85,               /* XsdNillable  */
  YYSYMBOL_XsdAttributes = 86,             /* XsdAttributes  */
  YYSYMBOL_Xception = 87,                  /* Xception  */
  YYSYMBOL_Service = 88,                   /* Service  */
  YYSYMBOL_FlagArgs = 89,                  /* FlagArgs  */
  YYSYMBOL_UnflagArgs = 90,                /* UnflagArgs  */
  YYSYMBOL_Extends = 91,                   /* Extends  */
  YYSYMBOL_FunctionList = 92,              /* FunctionList  */
  YYSYMBOL_Function = 93,                  /* Function  */
  YYSYMBOL_Oneway = 94,                    /* Oneway  */
  YYSYMBOL_Throws = 95,                    /* Throws  */
  YYSYMBOL_FieldList = 96,                 /* FieldList  */
  YYSYMBOL_Field = 97,                     /* Field  */
  YYSYMBOL_FieldIdentifier = 98,           /* FieldIdentifier  */
  YYSYMBOL_FieldReference = 99,            /* FieldReference  */
  YYSYMBOL_FieldRequiredness = 100,        /* FieldRequiredness  */
  YYSYMBOL_FieldValue = 101,               /* FieldValue  */
  YYSYMBOL_FunctionType = 102,             /* FunctionType  */
  YYSYMBOL_FieldType = 103,                /* FieldType  */
  YYSYMBOL_BaseType = 104,                 /* BaseType  */
  YYSYMBOL_SimpleBaseType = 105,           /* SimpleBaseType  */
  YYSYMBOL_ContainerType = 106,            /* ContainerType  */
  YYSYMBOL_SimpleContainerType = 107,      /* SimpleContainerType  */
  YYSYMBOL_MapType = 108,                  /* MapType  */
  YYSYMBOL_SetType = 109,                  /* SetType  */
  YYSYMBOL_ListType = 110,                 /* ListType  */
  YYSYMBOL_CppType = 111,                  /* CppType  */
  YYSYMBOL_TypeAnnotations = 112,          /* TypeAnnotations  */
  YYSYMBOL_TypeAnnotationList = 113,       /* TypeAnnotationList  */
  YYSYMBOL_TypeAnnotation = 114,           /* TypeAnnotation  */
  YYSYMBOL_TypeAnnotationValue = 115       /* TypeAnnotationValue  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   173

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  56
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  60
/* YYNRULES -- Number of rules.  */
#define YYNRULES  115
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  200

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   297


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      52,    53,    43,     2,    44,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    51,    45,
      54,    48,    55,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    49,     2,    50,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    46,     2,    47,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   250,   250,   262,   273,   282,   287,   292,   296,   308,
     316,   326,   339,   347,   352,   360,   375,   393,   400,   407,
     414,   421,   430,   432,   435,   438,   451,   479,   486,   493,
     507,   522,   534,   546,   553,   560,   567,   586,   595,   601,
     606,   612,   617,   624,   631,   638,   645,   652,   659,   666,
     670,   676,   691,   696,   701,   706,   711,   716,   721,   726,
     731,   745,   759,   764,   769,   782,   787,   794,   800,   815,
     820,   825,   835,   840,   850,   857,   891,   931,   941,   946,
     951,   955,   967,   972,   981,   986,   991,   998,  1017,  1022,
    1028,  1041,  1046,  1051,  1056,  1061,  1066,  1071,  1076,  1081,
    1087,  1098,  1103,  1108,  1115,  1125,  1135,  1146,  1151,  1156,
    1162,  1167,  1175,  1181,  1190,  1196
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "tok_identifier",
  "tok_literal", "tok_doctext", "tok_int_constant", "tok_dub_constant",
  "tok_include", "tok_namespace", "tok_cpp_include", "tok_cpp_type",
  "tok_xsd_all", "tok_xsd_optional", "tok_xsd_nillable", "tok_xsd_attrs",
  "tok_void", "tok_bool", "tok_string", "tok_binary", "tok_slist",
  "tok_senum", "tok_i8", "tok_i16", "tok_i32", "tok_i64", "tok_double",
  "tok_map", "tok_list", "tok_set", "tok_oneway", "tok_typedef",
  "tok_struct", "tok_xception", "tok_throws", "tok_extends", "tok_service",
  "tok_enum", "tok_const", "tok_required", "tok_optional", "tok_union",
  "tok_reference", "'*'", "','", "';'", "'{'", "'}'", "'='", "'['", "']'",
  "':'", "'('", "')'", "'<'", "'>'", "$accept", "Program",
  "CaptureDocText", "DestroyDocText", "HeaderList", "Header", "Include",
  "DefinitionList", "Definition", "TypeDefinition",
  "CommaOrSemicolonOptional", "Typedef", "Enum", "EnumDefList", "EnumDef",
  "EnumValue", "Senum", "SenumDefList", "SenumDef", "Const", "ConstValue",
  "ConstList", "ConstListContents", "ConstMap", "ConstMapContents",
  "StructHead", "Struct", "XsdAll", "XsdOptional", "XsdNillable",
  "XsdAttributes", "Xception", "Service", "FlagArgs", "UnflagArgs",
  "Extends", "FunctionList", "Function", "Oneway", "Throws", "FieldList",
  "Field", "FieldIdentifier", "FieldReference", "FieldRequiredness",
  "FieldValue", "FunctionType", "FieldType", "BaseType", "SimpleBaseType",
  "ContainerType", "SimpleContainerType", "MapType", "SetType", "ListType",
  "CppType", "TypeAnnotations", "TypeAnnotationList", "TypeAnnotation",
  "TypeAnnotationValue", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-124)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-64)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -124,    15,     9,  -124,    26,    33,    35,    13,    36,  -124,
    -124,   132,  -124,    39,    40,  -124,    41,   123,  -124,    42,
      45,    46,   123,  -124,  -124,  -124,  -124,  -124,  -124,  -124,
      61,  -124,  -124,  -124,    16,  -124,    19,  -124,  -124,  -124,
    -124,  -124,  -124,  -124,  -124,  -124,  -124,    56,    18,    56,
      70,  -124,    16,  -124,    16,  -124,  -124,  -124,    29,    43,
      30,    74,    68,  -124,  -124,  -124,    77,    28,   123,    34,
      16,  -124,  -124,  -124,    80,    38,  -124,    44,  -124,    48,
       7,     3,  -124,   123,    32,   123,   -23,    49,  -124,  -124,
      50,    25,  -124,    47,  -124,  -124,   -23,    16,  -124,    55,
      56,    65,  -124,  -124,  -124,    16,    84,  -124,  -124,    16,
      98,  -124,  -124,  -124,  -124,  -124,  -124,  -124,   -23,  -124,
    -124,    75,   117,   -23,  -124,  -124,   123,  -124,  -124,  -124,
      51,    -2,    76,  -124,    79,    16,     5,    20,  -124,    16,
    -124,  -124,    78,  -124,  -124,  -124,   123,    95,    82,  -124,
     124,   -23,  -124,    81,  -124,   -23,  -124,  -124,    89,  -124,
      90,    16,  -124,  -124,    25,  -124,  -124,   131,  -124,   133,
    -124,  -124,   -23,    87,    92,  -124,    25,   141,  -124,  -124,
    -124,   142,   102,  -124,   143,   125,   111,    16,   108,    16,
    -124,   -23,  -124,   -23,   114,  -124,   109,  -124,  -124,  -124
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       6,     0,    13,     1,     0,     3,     0,     0,     0,     5,
       7,     0,    11,     0,     0,    10,     0,     0,    49,     0,
       0,     0,     0,    50,    12,    15,    17,    18,    19,    14,
       0,    20,    21,    16,   110,     9,     0,    87,    94,    91,
      92,    93,    95,    96,    97,    98,    99,   108,     0,   108,
       0,    88,   110,    89,   110,   101,   102,   103,     0,    65,
       0,     0,    53,   112,     8,    34,     0,     0,     0,     0,
     110,    90,   100,    74,     0,     0,    28,     0,    52,     0,
       0,     0,   107,     0,     0,     0,    24,     3,    64,    62,
       3,     0,    74,   115,   109,   111,    24,   110,    33,     0,
     108,     0,    22,    23,    25,   110,    77,    73,    67,   110,
       0,    27,    40,    39,    37,    38,    48,    45,    24,    41,
      42,     3,     0,    24,    35,    32,     0,   106,   105,    60,
       0,    82,     3,    26,    31,   110,     0,     0,    36,   110,
     114,   113,     0,    76,    80,    81,     0,    70,     0,    66,
       0,    24,    46,     0,    43,    24,    51,   104,    79,    69,
       0,   110,    30,    29,     0,    44,    78,     0,    86,     0,
      85,    61,    24,    84,     0,    47,     0,    55,    74,    83,
      54,    57,     3,    56,    59,    72,     0,   110,     0,   110,
      74,    24,    74,    24,     3,    75,     3,    68,    58,    71
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
    -124,  -124,    -4,  -124,  -124,  -124,  -124,  -124,  -124,  -124,
     -93,  -124,  -124,  -124,  -124,  -124,  -124,  -124,  -124,  -124,
    -123,  -124,  -124,  -124,  -124,  -124,  -124,  -124,  -124,  -124,
    -124,  -124,  -124,  -124,  -124,  -124,  -124,  -124,  -124,  -124,
     -87,  -124,  -124,  -124,  -124,  -124,  -124,   -22,  -124,  -124,
    -124,  -124,  -124,  -124,  -124,   -43,   -50,  -124,  -124,  -124
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,   106,     4,     2,     9,    10,     5,    24,    25,
     104,    26,    27,    90,   111,   135,    28,    81,    98,    29,
     118,   119,   137,   120,   136,    30,    31,    79,   181,   184,
     187,    32,    33,   108,   148,    75,   132,   149,   160,   189,
      87,   107,   131,   167,   146,   177,   169,    50,    51,    52,
      53,    54,    55,    56,    57,    67,    64,    80,    95,   123
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      61,    11,    71,   124,    72,   121,    69,    96,   112,   113,
      93,   114,   115,   153,   155,     3,    13,    -4,    -4,    -4,
      86,   102,   103,   112,   113,   138,   114,   115,   112,   113,
     141,   114,   115,    -2,     6,     7,     8,   144,   145,    12,
      15,   172,    34,    35,    36,    58,    84,   125,    59,    60,
      97,   116,   152,   179,   117,   129,    14,   127,   163,   133,
      94,    99,   165,   101,    62,    65,   116,    66,    63,   117,
     154,   116,    68,    70,   117,    73,    76,    77,    74,   175,
      78,    82,    83,    88,    89,   151,   110,   100,    85,   156,
     130,   182,    91,    37,    92,   122,   105,   109,   195,   126,
     197,   134,   143,   194,   142,   196,   168,    38,    39,    40,
      41,   171,    42,    43,    44,    45,    46,    47,    48,    49,
     128,   140,   139,   -63,   158,   159,    37,   150,   147,   161,
     162,   166,   164,   157,   173,   176,   174,   191,   170,   193,
      38,    39,    40,    41,   178,    42,    43,    44,    45,    46,
      47,    48,    49,    16,   180,   185,   183,   190,   186,   188,
     192,   198,   199,    17,    18,    19,     0,     0,    20,    21,
      22,     0,     0,    23
};

static const yytype_int16 yycheck[] =
{
      22,     5,    52,    96,    54,    92,    49,     4,     3,     4,
       3,     6,     7,   136,   137,     0,     3,     8,     9,    10,
      70,    44,    45,     3,     4,   118,     6,     7,     3,     4,
     123,     6,     7,     0,     8,     9,    10,    39,    40,     4,
       4,   164,     3,     3,     3,     3,    68,    97,     3,     3,
      47,    46,    47,   176,    49,   105,    43,   100,   151,   109,
      53,    83,   155,    85,     3,    46,    46,    11,    52,    49,
      50,    46,    54,     3,    49,    46,    46,     3,    35,   172,
      12,     4,    54,     3,    46,   135,    90,    55,    54,   139,
       6,   178,    48,     3,    46,    48,    47,    47,   191,    44,
     193,     3,    51,   190,   126,   192,    16,    17,    18,    19,
      20,   161,    22,    23,    24,    25,    26,    27,    28,    29,
      55,     4,    47,    47,   146,    30,     3,    48,   132,    47,
       6,    42,    51,    55,     3,    48,     3,   187,   160,   189,
      17,    18,    19,    20,    52,    22,    23,    24,    25,    26,
      27,    28,    29,    21,    13,    53,    14,    46,    15,    34,
      52,    47,    53,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    -1,    41
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    57,    60,     0,    59,    63,     8,     9,    10,    61,
      62,    58,     4,     3,    43,     4,    21,    31,    32,    33,
      36,    37,    38,    41,    64,    65,    67,    68,    72,    75,
      81,    82,    87,    88,     3,     3,     3,     3,    17,    18,
      19,    20,    22,    23,    24,    25,    26,    27,    28,    29,
     103,   104,   105,   106,   107,   108,   109,   110,     3,     3,
       3,   103,     3,    52,   112,    46,    11,   111,    54,   111,
       3,   112,   112,    46,    35,    91,    46,     3,    12,    83,
     113,    73,     4,    54,   103,    54,   112,    96,     3,    46,
      69,    48,    46,     3,    53,   114,     4,    47,    74,   103,
      55,   103,    44,    45,    66,    47,    58,    97,    89,    47,
      58,    70,     3,     4,     6,     7,    46,    49,    76,    77,
      79,    96,    48,   115,    66,   112,    44,   111,    55,   112,
       6,    98,    92,   112,     3,    71,    80,    78,    66,    47,
       4,    66,   103,    51,    39,    40,   100,    58,    90,    93,
      48,   112,    47,    76,    50,    76,   112,    55,   103,    30,
      94,    47,     6,    66,    51,    66,    42,    99,    16,   102,
     103,   112,    76,     3,     3,    66,    48,   101,    52,    76,
      13,    84,    96,    14,    85,    53,    15,    86,    34,    95,
      46,   112,    52,   112,    96,    66,    96,    66,    47,    53
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    56,    57,    58,    59,    60,    60,    61,    61,    61,
      61,    62,    63,    63,    64,    64,    64,    65,    65,    65,
      65,    65,    66,    66,    66,    67,    68,    69,    69,    70,
      71,    71,    72,    73,    73,    74,    75,    76,    76,    76,
      76,    76,    76,    77,    78,    78,    79,    80,    80,    81,
      81,    82,    83,    83,    84,    84,    85,    85,    86,    86,
      87,    88,    89,    90,    91,    91,    92,    92,    93,    94,
      94,    95,    95,    96,    96,    97,    98,    98,    99,    99,
     100,   100,   100,   101,   101,   102,   102,   103,   103,   103,
     104,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     106,   107,   107,   107,   108,   109,   110,   111,   111,   112,
     112,   113,   113,   114,   115,   115
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     0,     0,     3,     0,     1,     4,     3,
       2,     2,     3,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     5,     6,     2,     0,     4,
       3,     1,     6,     2,     0,     2,     6,     1,     1,     1,
       1,     1,     1,     3,     3,     0,     3,     5,     0,     1,
       1,     7,     1,     0,     1,     0,     1,     0,     4,     0,
       6,     9,     0,     0,     2,     0,     2,     0,    10,     1,
       0,     4,     0,     2,     0,    12,     2,     0,     1,     0,
       1,     1,     0,     2,     0,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     7,     5,     5,     2,     0,     3,
       0,     2,     0,     3,     2,     0
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Program: HeaderList DefinitionList  */
#line 251 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Program -> Headers DefinitionList");
      if((g_program_doctext_candidate != nullptr) && (g_program_doctext_status != ALREADY_PROCESSED))
      {
        g_program->set_doc(g_program_doctext_candidate);
        g_program_doctext_status = ALREADY_PROCESSED;
      }
      clear_doctext();
    }
#line 1401 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 3: /* CaptureDocText: %empty  */
#line 262 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      if (g_parse_mode == PROGRAM) {
        (yyval.dtext) = g_doctext;
        g_doctext = nullptr;
      } else {
        (yyval.dtext) = nullptr;
      }
    }
#line 1414 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 4: /* DestroyDocText: %empty  */
#line 273 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      if (g_parse_mode == PROGRAM) {
        clear_doctext();
      }
    }
#line 1424 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 5: /* HeaderList: HeaderList DestroyDocText Header  */
#line 283 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("HeaderList -> HeaderList Header");
    }
#line 1432 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 6: /* HeaderList: %empty  */
#line 287 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("HeaderList -> ");
    }
#line 1440 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 7: /* Header: Include  */
#line 293 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Header -> Include");
    }
#line 1448 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 8: /* Header: tok_namespace tok_identifier tok_identifier TypeAnnotations  */
#line 297 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Header -> tok_namespace tok_identifier tok_identifier");
      declare_valid_program_doctext();
      if (g_parse_mode == PROGRAM) {
        g_program->set_namespace((yyvsp[-2].id), (yyvsp[-1].id));
      }
      if ((yyvsp[0].ttype) != nullptr) {
        g_program->set_namespace_annotations((yyvsp[-2].id), (yyvsp[0].ttype)->annotations_);
        delete (yyvsp[0].ttype);
      }
    }
#line 1464 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 9: /* Header: tok_namespace '*' tok_identifier  */
#line 309 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Header -> tok_namespace * tok_identifier");
      declare_valid_program_doctext();
      if (g_parse_mode == PROGRAM) {
        g_program->set_namespace("*", (yyvsp[0].id));
      }
    }
#line 1476 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 10: /* Header: tok_cpp_include tok_literal  */
#line 317 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Header -> tok_cpp_include tok_literal");
      declare_valid_program_doctext();
      if (g_parse_mode == PROGRAM) {
        g_program->add_cpp_include((yyvsp[0].id));
      }
    }
#line 1488 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 11: /* Include: tok_include tok_literal  */
#line 327 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Include -> tok_include tok_literal");
      declare_valid_program_doctext();
      if (g_parse_mode == INCLUDES) {
        std::string path = include_file(std::string((yyvsp[0].id)));
        if (!path.empty()) {
          g_program->add_include(path, std::string((yyvsp[0].id)));
        }
      }
    }
#line 1503 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 12: /* DefinitionList: DefinitionList CaptureDocText Definition  */
#line 340 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("DefinitionList -> DefinitionList Definition");
      if ((yyvsp[-1].dtext) != nullptr && (yyvsp[0].tdoc) != nullptr) {
        (yyvsp[0].tdoc)->set_doc((yyvsp[-1].dtext));
      }
    }
#line 1514 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 13: /* DefinitionList: %empty  */
#line 347 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("DefinitionList -> ");
    }
#line 1522 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 14: /* Definition: Const  */
#line 353 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Definition -> Const");
      if (g_parse_mode == PROGRAM) {
        g_program->add_const((yyvsp[0].tconst));
      }
      (yyval.tdoc) = (yyvsp[0].tconst);
    }
#line 1534 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 15: /* Definition: TypeDefinition  */
#line 361 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Definition -> TypeDefinition");
      if (g_parse_mode == PROGRAM) {
        g_scope->add_type((yyvsp[0].ttype)->get_name(), (yyvsp[0].ttype));
        if (g_parent_scope != nullptr) {
          g_parent_scope->add_type(g_parent_prefix + (yyvsp[0].ttype)->get_name(), (yyvsp[0].ttype));
        }
        if (! g_program->is_unique_typename((yyvsp[0].ttype))) {
          yyerror("Type \"%s\" is already defined.", (yyvsp[0].ttype)->get_name().c_str());
          exit(1);
        }
      }
      (yyval.tdoc) = (yyvsp[0].ttype);
    }
#line 1553 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 16: /* Definition: Service  */
#line 376 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Definition -> Service");
      if (g_parse_mode == PROGRAM) {
        g_scope->add_service((yyvsp[0].tservice)->get_name(), (yyvsp[0].tservice));
        if (g_parent_scope != nullptr) {
          g_parent_scope->add_service(g_parent_prefix + (yyvsp[0].tservice)->get_name(), (yyvsp[0].tservice));
        }
        g_program->add_service((yyvsp[0].tservice));
        if (! g_program->is_unique_typename((yyvsp[0].tservice))) {
          yyerror("Type \"%s\" is already defined.", (yyvsp[0].tservice)->get_name().c_str());
          exit(1);
        }
      }
      (yyval.tdoc) = (yyvsp[0].tservice);
    }
#line 1573 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 17: /* TypeDefinition: Typedef  */
#line 394 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("TypeDefinition -> Typedef");
      if (g_parse_mode == PROGRAM) {
        g_program->add_typedef((yyvsp[0].ttypedef));
      }
    }
#line 1584 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 18: /* TypeDefinition: Enum  */
#line 401 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("TypeDefinition -> Enum");
      if (g_parse_mode == PROGRAM) {
        g_program->add_enum((yyvsp[0].tenum));
      }
    }
#line 1595 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 19: /* TypeDefinition: Senum  */
#line 408 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("TypeDefinition -> Senum");
      if (g_parse_mode == PROGRAM) {
        g_program->add_typedef((yyvsp[0].ttypedef));
      }
    }
#line 1606 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 20: /* TypeDefinition: Struct  */
#line 415 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("TypeDefinition -> Struct");
      if (g_parse_mode == PROGRAM) {
        g_program->add_struct((yyvsp[0].tstruct));
      }
    }
#line 1617 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 21: /* TypeDefinition: Xception  */
#line 422 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("TypeDefinition -> Xception");
      if (g_parse_mode == PROGRAM) {
        g_program->add_xception((yyvsp[0].tstruct));
      }
    }
#line 1628 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 22: /* CommaOrSemicolonOptional: ','  */
#line 431 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {}
#line 1634 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 23: /* CommaOrSemicolonOptional: ';'  */
#line 433 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {}
#line 1640 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 24: /* CommaOrSemicolonOptional: %empty  */
#line 435 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {}
#line 1646 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 25: /* Typedef: tok_typedef FieldType tok_identifier TypeAnnotations CommaOrSemicolonOptional  */
#line 439 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("TypeDef -> tok_typedef FieldType tok_identifier");
      validate_simple_identifier( (yyvsp[-2].id));
      t_typedef *td = new t_typedef(g_program, (yyvsp[-3].ttype), (yyvsp[-2].id));
      (yyval.ttypedef) = td;
      if ((yyvsp[-1].ttype) != nullptr) {
        (yyval.ttypedef)->annotations_ = (yyvsp[-1].ttype)->annotations_;
        delete (yyvsp[-1].ttype);
      }
    }
#line 1661 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 26: /* Enum: tok_enum tok_identifier '{' EnumDefList '}' TypeAnnotations  */
#line 452 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Enum -> tok_enum tok_identifier { EnumDefList }");
      (yyval.tenum) = (yyvsp[-2].tenum);
      validate_simple_identifier( (yyvsp[-4].id));
      (yyval.tenum)->set_name((yyvsp[-4].id));
      if ((yyvsp[0].ttype) != nullptr) {
        (yyval.tenum)->annotations_ = (yyvsp[0].ttype)->annotations_;
        delete (yyvsp[0].ttype);
      }

      // make constants for all the enum values
      if (g_parse_mode == PROGRAM) {
        const std::vector<t_enum_value*>& enum_values = (yyval.tenum)->get_constants();
        std::vector<t_enum_value*>::const_iterator c_iter;
        for (c_iter = enum_values.begin(); c_iter != enum_values.end(); ++c_iter) {
          std::string const_name = (yyval.tenum)->get_name() + "." + (*c_iter)->get_name();
          t_const_value* const_val = new t_const_value((*c_iter)->get_value());
          const_val->set_enum((yyval.tenum));
          g_scope->add_constant(const_name, new t_const(g_type_i32, (*c_iter)->get_name(), const_val));
          if (g_parent_scope != nullptr) {
            g_parent_scope->add_constant(g_parent_prefix + const_name, new t_const(g_type_i32, (*c_iter)->get_name(), const_val));
          }
        }
      }
    }
#line 1691 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 27: /* EnumDefList: EnumDefList EnumDef  */
#line 480 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("EnumDefList -> EnumDefList EnumDef");
      (yyval.tenum) = (yyvsp[-1].tenum);
      (yyval.tenum)->append((yyvsp[0].tenumv));
    }
#line 1701 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 28: /* EnumDefList: %empty  */
#line 486 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("EnumDefList -> ");
      (yyval.tenum) = new t_enum(g_program);
      y_enum_val = -1;
    }
#line 1711 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 29: /* EnumDef: CaptureDocText EnumValue TypeAnnotations CommaOrSemicolonOptional  */
#line 494 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("EnumDef -> EnumValue");
      (yyval.tenumv) = (yyvsp[-2].tenumv);
      if ((yyvsp[-3].dtext) != nullptr) {
        (yyval.tenumv)->set_doc((yyvsp[-3].dtext));
      }
	  if ((yyvsp[-1].ttype) != nullptr) {
        (yyval.tenumv)->annotations_ = (yyvsp[-1].ttype)->annotations_;
        delete (yyvsp[-1].ttype);
      }
    }
#line 1727 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 30: /* EnumValue: tok_identifier '=' tok_int_constant  */
#line 508 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("EnumValue -> tok_identifier = tok_int_constant");
      if ((yyvsp[0].iconst) < INT32_MIN || (yyvsp[0].iconst) > INT32_MAX) {
        // Note: this used to be just a warning.  However, since thrift always
        // treats enums as i32 values, I'm changing it to a fatal error.
        // I doubt this will affect many people, but users who run into this
        // will have to update their thrift files to manually specify the
        // truncated i32 value that thrift has always been using anyway.
        failure("64-bit value supplied for enum %s will be truncated.", (yyvsp[-2].id));
      }
      y_enum_val = static_cast<int32_t>((yyvsp[0].iconst));
      (yyval.tenumv) = new t_enum_value((yyvsp[-2].id), y_enum_val);
    }
#line 1745 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 31: /* EnumValue: tok_identifier  */
#line 523 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("EnumValue -> tok_identifier");
      validate_simple_identifier( (yyvsp[0].id));
      if (y_enum_val == INT32_MAX) {
        failure("enum value overflow at enum %s", (yyvsp[0].id));
      }
      ++y_enum_val;
      (yyval.tenumv) = new t_enum_value((yyvsp[0].id), y_enum_val);
    }
#line 1759 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 32: /* Senum: tok_senum tok_identifier '{' SenumDefList '}' TypeAnnotations  */
#line 535 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Senum -> tok_senum tok_identifier { SenumDefList }");
      validate_simple_identifier( (yyvsp[-4].id));
      (yyval.ttypedef) = new t_typedef(g_program, (yyvsp[-2].tbase), (yyvsp[-4].id));
      if ((yyvsp[0].ttype) != nullptr) {
        (yyval.ttypedef)->annotations_ = (yyvsp[0].ttype)->annotations_;
        delete (yyvsp[0].ttype);
      }
    }
#line 1773 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 33: /* SenumDefList: SenumDefList SenumDef  */
#line 547 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("SenumDefList -> SenumDefList SenumDef");
      (yyval.tbase) = (yyvsp[-1].tbase);
      (yyval.tbase)->add_string_enum_val((yyvsp[0].id));
    }
#line 1783 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 34: /* SenumDefList: %empty  */
#line 553 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("SenumDefList -> ");
      (yyval.tbase) = new t_base_type("string", t_base_type::TYPE_STRING);
      (yyval.tbase)->set_string_enum(true);
    }
#line 1793 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 35: /* SenumDef: tok_literal CommaOrSemicolonOptional  */
#line 561 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("SenumDef -> tok_literal");
      (yyval.id) = (yyvsp[-1].id);
    }
#line 1802 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 36: /* Const: tok_const FieldType tok_identifier '=' ConstValue CommaOrSemicolonOptional  */
#line 568 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Const -> tok_const FieldType tok_identifier = ConstValue");
      if (g_parse_mode == PROGRAM) {
        validate_simple_identifier( (yyvsp[-3].id));
        g_scope->resolve_const_value((yyvsp[-1].tconstv), (yyvsp[-4].ttype));
        (yyval.tconst) = new t_const((yyvsp[-4].ttype), (yyvsp[-3].id), (yyvsp[-1].tconstv));
        validate_const_type((yyval.tconst));

        g_scope->add_constant((yyvsp[-3].id), (yyval.tconst));
        if (g_parent_scope != nullptr) {
          g_parent_scope->add_constant(g_parent_prefix + (yyvsp[-3].id), (yyval.tconst));
        }
      } else {
        (yyval.tconst) = nullptr;
      }
    }
#line 1823 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 37: /* ConstValue: tok_int_constant  */
#line 587 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ConstValue => tok_int_constant");
      (yyval.tconstv) = new t_const_value();
      (yyval.tconstv)->set_integer((yyvsp[0].iconst));
      if (!g_allow_64bit_consts && ((yyvsp[0].iconst) < INT32_MIN || (yyvsp[0].iconst) > INT32_MAX)) {
        pwarning(1, "64-bit constant \"%" PRIi64"\" may not work in all languages.\n", (yyvsp[0].iconst));
      }
    }
#line 1836 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 38: /* ConstValue: tok_dub_constant  */
#line 596 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ConstValue => tok_dub_constant");
      (yyval.tconstv) = new t_const_value();
      (yyval.tconstv)->set_double((yyvsp[0].dconst));
    }
#line 1846 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 39: /* ConstValue: tok_literal  */
#line 602 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ConstValue => tok_literal");
      (yyval.tconstv) = new t_const_value((yyvsp[0].id));
    }
#line 1855 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 40: /* ConstValue: tok_identifier  */
#line 607 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ConstValue => tok_identifier");
      (yyval.tconstv) = new t_const_value();
      (yyval.tconstv)->set_identifier((yyvsp[0].id));
    }
#line 1865 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 41: /* ConstValue: ConstList  */
#line 613 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ConstValue => ConstList");
      (yyval.tconstv) = (yyvsp[0].tconstv);
    }
#line 1874 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 42: /* ConstValue: ConstMap  */
#line 618 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ConstValue => ConstMap");
      (yyval.tconstv) = (yyvsp[0].tconstv);
    }
#line 1883 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 43: /* ConstList: '[' ConstListContents ']'  */
#line 625 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ConstList => [ ConstListContents ]");
      (yyval.tconstv) = (yyvsp[-1].tconstv);
    }
#line 1892 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 44: /* ConstListContents: ConstListContents ConstValue CommaOrSemicolonOptional  */
#line 632 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ConstListContents => ConstListContents ConstValue CommaOrSemicolonOptional");
      (yyval.tconstv) = (yyvsp[-2].tconstv);
      (yyval.tconstv)->add_list((yyvsp[-1].tconstv));
    }
#line 1902 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 45: /* ConstListContents: %empty  */
#line 638 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ConstListContents =>");
      (yyval.tconstv) = new t_const_value();
      (yyval.tconstv)->set_list();
    }
#line 1912 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 46: /* ConstMap: '{' ConstMapContents '}'  */
#line 646 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ConstMap => { ConstMapContents }");
      (yyval.tconstv) = (yyvsp[-1].tconstv);
    }
#line 1921 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 47: /* ConstMapContents: ConstMapContents ConstValue ':' ConstValue CommaOrSemicolonOptional  */
#line 653 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ConstMapContents => ConstMapContents ConstValue CommaOrSemicolonOptional");
      (yyval.tconstv) = (yyvsp[-4].tconstv);
      (yyval.tconstv)->add_map((yyvsp[-3].tconstv), (yyvsp[-1].tconstv));
    }
#line 1931 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 48: /* ConstMapContents: %empty  */
#line 659 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ConstMapContents =>");
      (yyval.tconstv) = new t_const_value();
      (yyval.tconstv)->set_map();
    }
#line 1941 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 49: /* StructHead: tok_struct  */
#line 667 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.iconst) = struct_is_struct;
    }
#line 1949 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 50: /* StructHead: tok_union  */
#line 671 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.iconst) = struct_is_union;
    }
#line 1957 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 51: /* Struct: StructHead tok_identifier XsdAll '{' FieldList '}' TypeAnnotations  */
#line 677 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Struct -> tok_struct tok_identifier { FieldList }");
      validate_simple_identifier( (yyvsp[-5].id));
      (yyvsp[-2].tstruct)->set_xsd_all((yyvsp[-4].tbool));
      (yyvsp[-2].tstruct)->set_union((yyvsp[-6].iconst) == struct_is_union);
      (yyval.tstruct) = (yyvsp[-2].tstruct);
      (yyval.tstruct)->set_name((yyvsp[-5].id));
      if ((yyvsp[0].ttype) != nullptr) {
        (yyval.tstruct)->annotations_ = (yyvsp[0].ttype)->annotations_;
        delete (yyvsp[0].ttype);
      }
    }
#line 1974 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 52: /* XsdAll: tok_xsd_all  */
#line 692 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tbool) = true;
    }
#line 1982 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 53: /* XsdAll: %empty  */
#line 696 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tbool) = false;
    }
#line 1990 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 54: /* XsdOptional: tok_xsd_optional  */
#line 702 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tbool) = true;
    }
#line 1998 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 55: /* XsdOptional: %empty  */
#line 706 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tbool) = false;
    }
#line 2006 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 56: /* XsdNillable: tok_xsd_nillable  */
#line 712 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tbool) = true;
    }
#line 2014 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 57: /* XsdNillable: %empty  */
#line 716 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tbool) = false;
    }
#line 2022 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 58: /* XsdAttributes: tok_xsd_attrs '{' FieldList '}'  */
#line 722 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tstruct) = (yyvsp[-1].tstruct);
    }
#line 2030 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 59: /* XsdAttributes: %empty  */
#line 726 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tstruct) = nullptr;
    }
#line 2038 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 60: /* Xception: tok_xception tok_identifier '{' FieldList '}' TypeAnnotations  */
#line 732 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Xception -> tok_xception tok_identifier { FieldList }");
      validate_simple_identifier( (yyvsp[-4].id));
      (yyvsp[-2].tstruct)->set_name((yyvsp[-4].id));
      (yyvsp[-2].tstruct)->set_xception(true);
      (yyval.tstruct) = (yyvsp[-2].tstruct);
      if ((yyvsp[0].ttype) != nullptr) {
        (yyval.tstruct)->annotations_ = (yyvsp[0].ttype)->annotations_;
        delete (yyvsp[0].ttype);
      }
    }
#line 2054 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 61: /* Service: tok_service tok_identifier Extends '{' FlagArgs FunctionList UnflagArgs '}' TypeAnnotations  */
#line 746 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Service -> tok_service tok_identifier { FunctionList }");
      validate_simple_identifier( (yyvsp[-7].id));
      (yyval.tservice) = (yyvsp[-3].tservice);
      (yyval.tservice)->set_name((yyvsp[-7].id));
      (yyval.tservice)->set_extends((yyvsp[-6].tservice));
      if ((yyvsp[0].ttype) != nullptr) {
        (yyval.tservice)->annotations_ = (yyvsp[0].ttype)->annotations_;
        delete (yyvsp[0].ttype);
      }
    }
#line 2070 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 62: /* FlagArgs: %empty  */
#line 759 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
       g_arglist = 1;
    }
#line 2078 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 63: /* UnflagArgs: %empty  */
#line 764 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
       g_arglist = 0;
    }
#line 2086 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 64: /* Extends: tok_extends tok_identifier  */
#line 770 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Extends -> tok_extends tok_identifier");
      (yyval.tservice) = nullptr;
      if (g_parse_mode == PROGRAM) {
        (yyval.tservice) = g_scope->get_service((yyvsp[0].id));
        if ((yyval.tservice) == nullptr) {
          yyerror("Service \"%s\" has not been defined.", (yyvsp[0].id));
          exit(1);
        }
      }
    }
#line 2102 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 65: /* Extends: %empty  */
#line 782 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tservice) = nullptr;
    }
#line 2110 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 66: /* FunctionList: FunctionList Function  */
#line 788 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("FunctionList -> FunctionList Function");
      (yyval.tservice) = (yyvsp[-1].tservice);
      (yyvsp[-1].tservice)->add_function((yyvsp[0].tfunction));
    }
#line 2120 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 67: /* FunctionList: %empty  */
#line 794 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("FunctionList -> ");
      (yyval.tservice) = new t_service(g_program);
    }
#line 2129 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 68: /* Function: CaptureDocText Oneway FunctionType tok_identifier '(' FieldList ')' Throws TypeAnnotations CommaOrSemicolonOptional  */
#line 801 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      validate_simple_identifier( (yyvsp[-6].id));
      (yyvsp[-4].tstruct)->set_name(std::string((yyvsp[-6].id)) + "_args");
      (yyval.tfunction) = new t_function((yyvsp[-7].ttype), (yyvsp[-6].id), (yyvsp[-4].tstruct), (yyvsp[-2].tstruct), (yyvsp[-8].tbool));
      if ((yyvsp[-9].dtext) != nullptr) {
        (yyval.tfunction)->set_doc((yyvsp[-9].dtext));
      }
      if ((yyvsp[-1].ttype) != nullptr) {
        (yyval.tfunction)->annotations_ = (yyvsp[-1].ttype)->annotations_;
        delete (yyvsp[-1].ttype);
      }
    }
#line 2146 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 69: /* Oneway: tok_oneway  */
#line 816 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tbool) = true;
    }
#line 2154 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 70: /* Oneway: %empty  */
#line 820 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tbool) = false;
    }
#line 2162 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 71: /* Throws: tok_throws '(' FieldList ')'  */
#line 826 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("Throws -> tok_throws ( FieldList )");
      (yyval.tstruct) = (yyvsp[-1].tstruct);
      if (g_parse_mode == PROGRAM && !validate_throws((yyval.tstruct))) {
        yyerror("Throws clause may not contain non-exception types");
        exit(1);
      }
    }
#line 2175 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 72: /* Throws: %empty  */
#line 835 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tstruct) = new t_struct(g_program);
    }
#line 2183 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 73: /* FieldList: FieldList Field  */
#line 841 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("FieldList -> FieldList , Field");
      (yyval.tstruct) = (yyvsp[-1].tstruct);
      if (!((yyval.tstruct)->append((yyvsp[0].tfield)))) {
        yyerror("\"%d: %s\" - field identifier/name has already been used", (yyvsp[0].tfield)->get_key(), (yyvsp[0].tfield)->get_name().c_str());
        exit(1);
      }
    }
#line 2196 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 74: /* FieldList: %empty  */
#line 850 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("FieldList -> ");
      y_field_val = -1;
      (yyval.tstruct) = new t_struct(g_program);
    }
#line 2206 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 75: /* Field: CaptureDocText FieldIdentifier FieldRequiredness FieldType FieldReference tok_identifier FieldValue XsdOptional XsdNillable XsdAttributes TypeAnnotations CommaOrSemicolonOptional  */
#line 858 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("tok_int_constant : Field -> FieldType tok_identifier");
      if ((yyvsp[-10].tfieldid).auto_assigned) {
        pwarning(1, "No field key specified for %s, resulting protocol may have conflicts or not be backwards compatible!\n", (yyvsp[-6].id));
        if (g_strict >= 192) {
          yyerror("Implicit field keys are deprecated and not allowed with -strict");
          exit(1);
        }
      }
      validate_simple_identifier((yyvsp[-6].id));
      (yyval.tfield) = new t_field((yyvsp[-8].ttype), (yyvsp[-6].id), (yyvsp[-10].tfieldid).value);
      (yyval.tfield)->set_reference((yyvsp[-7].tbool));
      (yyval.tfield)->set_req((yyvsp[-9].ereq));
      if ((yyvsp[-5].tconstv) != nullptr) {
        g_scope->resolve_const_value((yyvsp[-5].tconstv), (yyvsp[-8].ttype));
        validate_field_value((yyval.tfield), (yyvsp[-5].tconstv));
        (yyval.tfield)->set_value((yyvsp[-5].tconstv));
      }
      (yyval.tfield)->set_xsd_optional((yyvsp[-4].tbool));
      (yyval.tfield)->set_xsd_nillable((yyvsp[-3].tbool));
      if ((yyvsp[-11].dtext) != nullptr) {
        (yyval.tfield)->set_doc((yyvsp[-11].dtext));
      }
      if ((yyvsp[-2].tstruct) != nullptr) {
        (yyval.tfield)->set_xsd_attrs((yyvsp[-2].tstruct));
      }
      if ((yyvsp[-1].ttype) != nullptr) {
        (yyval.tfield)->annotations_ = (yyvsp[-1].ttype)->annotations_;
        delete (yyvsp[-1].ttype);
      }
    }
#line 2242 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 76: /* FieldIdentifier: tok_int_constant ':'  */
#line 892 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      if ((yyvsp[-1].iconst) <= 0) {
        if (g_allow_neg_field_keys) {
          /*
           * g_allow_neg_field_keys exists to allow users to add explicitly
           * specified key values to old .thrift files without breaking
           * protocol compatibility.
           */
          if ((yyvsp[-1].iconst) != y_field_val) {
            /*
             * warn if the user-specified negative value isn't what
             * thrift would have auto-assigned.
             */
            pwarning(1, "Nonpositive field key (%" PRIi64") differs from what would be "
                     "auto-assigned by thrift (%d).\n", (yyvsp[-1].iconst), y_field_val);
          }
          /*
           * Leave $1 as-is, and update y_field_val to be one less than $1.
           * The FieldList parsing will catch any duplicate key values.
           */
          y_field_val = static_cast<int32_t>((yyvsp[-1].iconst) - 1);
          (yyval.tfieldid).value = static_cast<int32_t>((yyvsp[-1].iconst));
          (yyval.tfieldid).auto_assigned = false;
        } else {
          pwarning(1, "Nonpositive value (%d) not allowed as a field key.\n",
                   (yyvsp[-1].iconst));
          (yyval.tfieldid).value = y_field_val--;
          (yyval.tfieldid).auto_assigned = true;
        }
      } else {
        (yyval.tfieldid).value = static_cast<int32_t>((yyvsp[-1].iconst));
        (yyval.tfieldid).auto_assigned = false;
      }
      if( (SHRT_MIN > (yyval.tfieldid).value) || ((yyval.tfieldid).value > SHRT_MAX)) {
        pwarning(1, "Field key (%d) exceeds allowed range (%d..%d).\n",
                 (yyval.tfieldid).value, SHRT_MIN, SHRT_MAX);
      }
    }
#line 2285 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 77: /* FieldIdentifier: %empty  */
#line 931 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tfieldid).value = y_field_val--;
      (yyval.tfieldid).auto_assigned = true;
      if( (SHRT_MIN > (yyval.tfieldid).value) || ((yyval.tfieldid).value > SHRT_MAX)) {
        pwarning(1, "Field key (%d) exceeds allowed range (%d..%d).\n",
                 (yyval.tfieldid).value, SHRT_MIN, SHRT_MAX);
      }
    }
#line 2298 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 78: /* FieldReference: tok_reference  */
#line 942 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tbool) = true;
    }
#line 2306 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 79: /* FieldReference: %empty  */
#line 946 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
   {
     (yyval.tbool) = false;
   }
#line 2314 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 80: /* FieldRequiredness: tok_required  */
#line 952 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.ereq) = t_field::T_REQUIRED;
    }
#line 2322 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 81: /* FieldRequiredness: tok_optional  */
#line 956 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      if (g_arglist) {
        if (g_parse_mode == PROGRAM) {
          pwarning(1, "optional keyword is ignored in argument lists.\n");
        }
        (yyval.ereq) = t_field::T_OPT_IN_REQ_OUT;
      } else {
        (yyval.ereq) = t_field::T_OPTIONAL;
      }
    }
#line 2337 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 82: /* FieldRequiredness: %empty  */
#line 967 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.ereq) = t_field::T_OPT_IN_REQ_OUT;
    }
#line 2345 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 83: /* FieldValue: '=' ConstValue  */
#line 973 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      if (g_parse_mode == PROGRAM) {
        (yyval.tconstv) = (yyvsp[0].tconstv);
      } else {
        (yyval.tconstv) = nullptr;
      }
    }
#line 2357 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 84: /* FieldValue: %empty  */
#line 981 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.tconstv) = nullptr;
    }
#line 2365 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 85: /* FunctionType: FieldType  */
#line 987 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("FunctionType -> FieldType");
      (yyval.ttype) = (yyvsp[0].ttype);
    }
#line 2374 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 86: /* FunctionType: tok_void  */
#line 992 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("FunctionType -> tok_void");
      (yyval.ttype) = g_type_void;
    }
#line 2383 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 87: /* FieldType: tok_identifier  */
#line 999 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("FieldType -> tok_identifier");
      if (g_parse_mode == INCLUDES) {
        // Ignore identifiers in include mode
        (yyval.ttype) = nullptr;
      } else {
        // Lookup the identifier in the current scope
        (yyval.ttype) = g_scope->get_type((yyvsp[0].id));
        if ((yyval.ttype) == nullptr) {
          /*
           * Either this type isn't yet declared, or it's never
             declared.  Either way allow it and we'll figure it out
             during generation.
           */
          (yyval.ttype) = new t_typedef(g_program, (yyvsp[0].id), true);
        }
      }
    }
#line 2406 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 88: /* FieldType: BaseType  */
#line 1018 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("FieldType -> BaseType");
      (yyval.ttype) = (yyvsp[0].ttype);
    }
#line 2415 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 89: /* FieldType: ContainerType  */
#line 1023 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("FieldType -> ContainerType");
      (yyval.ttype) = (yyvsp[0].ttype);
    }
#line 2424 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 90: /* BaseType: SimpleBaseType TypeAnnotations  */
#line 1029 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("BaseType -> SimpleBaseType TypeAnnotations");
      if ((yyvsp[0].ttype) != nullptr) {
        (yyval.ttype) = new t_base_type(*static_cast<t_base_type*>((yyvsp[-1].ttype)));
        (yyval.ttype)->annotations_ = (yyvsp[0].ttype)->annotations_;
        delete (yyvsp[0].ttype);
      } else {
        (yyval.ttype) = (yyvsp[-1].ttype);
      }
    }
#line 2439 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 91: /* SimpleBaseType: tok_string  */
#line 1042 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("BaseType -> tok_string");
      (yyval.ttype) = g_type_string;
    }
#line 2448 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 92: /* SimpleBaseType: tok_binary  */
#line 1047 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("BaseType -> tok_binary");
      (yyval.ttype) = g_type_binary;
    }
#line 2457 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 93: /* SimpleBaseType: tok_slist  */
#line 1052 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("BaseType -> tok_slist");
      (yyval.ttype) = g_type_slist;
    }
#line 2466 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 94: /* SimpleBaseType: tok_bool  */
#line 1057 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("BaseType -> tok_bool");
      (yyval.ttype) = g_type_bool;
    }
#line 2475 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 95: /* SimpleBaseType: tok_i8  */
#line 1062 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("BaseType -> tok_i8");
      (yyval.ttype) = g_type_i8;
    }
#line 2484 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 96: /* SimpleBaseType: tok_i16  */
#line 1067 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("BaseType -> tok_i16");
      (yyval.ttype) = g_type_i16;
    }
#line 2493 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 97: /* SimpleBaseType: tok_i32  */
#line 1072 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("BaseType -> tok_i32");
      (yyval.ttype) = g_type_i32;
    }
#line 2502 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 98: /* SimpleBaseType: tok_i64  */
#line 1077 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("BaseType -> tok_i64");
      (yyval.ttype) = g_type_i64;
    }
#line 2511 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 99: /* SimpleBaseType: tok_double  */
#line 1082 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("BaseType -> tok_double");
      (yyval.ttype) = g_type_double;
    }
#line 2520 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 100: /* ContainerType: SimpleContainerType TypeAnnotations  */
#line 1088 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ContainerType -> SimpleContainerType TypeAnnotations");
      (yyval.ttype) = (yyvsp[-1].ttype);
      if ((yyvsp[0].ttype) != nullptr) {
        (yyval.ttype)->annotations_ = (yyvsp[0].ttype)->annotations_;
        delete (yyvsp[0].ttype);
      }
    }
#line 2533 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 101: /* SimpleContainerType: MapType  */
#line 1099 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("SimpleContainerType -> MapType");
      (yyval.ttype) = (yyvsp[0].ttype);
    }
#line 2542 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 102: /* SimpleContainerType: SetType  */
#line 1104 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("SimpleContainerType -> SetType");
      (yyval.ttype) = (yyvsp[0].ttype);
    }
#line 2551 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 103: /* SimpleContainerType: ListType  */
#line 1109 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("SimpleContainerType -> ListType");
      (yyval.ttype) = (yyvsp[0].ttype);
    }
#line 2560 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 104: /* MapType: tok_map CppType '<' FieldType ',' FieldType '>'  */
#line 1116 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("MapType -> tok_map <FieldType, FieldType>");
      (yyval.ttype) = new t_map((yyvsp[-3].ttype), (yyvsp[-1].ttype));
      if ((yyvsp[-5].id) != nullptr) {
        ((t_container*)(yyval.ttype))->set_cpp_name(std::string((yyvsp[-5].id)));
      }
    }
#line 2572 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 105: /* SetType: tok_set CppType '<' FieldType '>'  */
#line 1126 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("SetType -> tok_set<FieldType>");
      (yyval.ttype) = new t_set((yyvsp[-1].ttype));
      if ((yyvsp[-3].id) != nullptr) {
        ((t_container*)(yyval.ttype))->set_cpp_name(std::string((yyvsp[-3].id)));
      }
    }
#line 2584 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 106: /* ListType: tok_list '<' FieldType '>' CppType  */
#line 1136 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("ListType -> tok_list<FieldType>");
      check_for_list_of_bytes((yyvsp[-2].ttype));
      (yyval.ttype) = new t_list((yyvsp[-2].ttype));
      if ((yyvsp[0].id) != nullptr) {
        ((t_container*)(yyval.ttype))->set_cpp_name(std::string((yyvsp[0].id)));
      }
    }
#line 2597 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 107: /* CppType: tok_cpp_type tok_literal  */
#line 1147 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.id) = (yyvsp[0].id);
    }
#line 2605 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 108: /* CppType: %empty  */
#line 1151 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.id) = nullptr;
    }
#line 2613 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 109: /* TypeAnnotations: '(' TypeAnnotationList ')'  */
#line 1157 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("TypeAnnotations -> ( TypeAnnotationList )");
      (yyval.ttype) = (yyvsp[-1].ttype);
    }
#line 2622 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 110: /* TypeAnnotations: %empty  */
#line 1162 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      (yyval.ttype) = nullptr;
    }
#line 2630 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 111: /* TypeAnnotationList: TypeAnnotationList TypeAnnotation  */
#line 1168 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("TypeAnnotationList -> TypeAnnotationList , TypeAnnotation");
      (yyval.ttype) = (yyvsp[-1].ttype);
      (yyval.ttype)->annotations_[(yyvsp[0].tannot)->key] = (yyvsp[0].tannot)->val;
      delete (yyvsp[0].tannot);
    }
#line 2641 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 112: /* TypeAnnotationList: %empty  */
#line 1175 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      /* Just use a dummy structure to hold the annotations. */
      (yyval.ttype) = new t_struct(g_program);
    }
#line 2650 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 113: /* TypeAnnotation: tok_identifier TypeAnnotationValue CommaOrSemicolonOptional  */
#line 1182 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("TypeAnnotation -> TypeAnnotationValue");
      (yyval.tannot) = new t_annotation;
      (yyval.tannot)->key = (yyvsp[-2].id);
      (yyval.tannot)->val = (yyvsp[-1].id);
    }
#line 2661 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 114: /* TypeAnnotationValue: '=' tok_literal  */
#line 1191 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("TypeAnnotationValue -> = tok_literal");
      (yyval.id) = (yyvsp[0].id);
    }
#line 2670 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;

  case 115: /* TypeAnnotationValue: %empty  */
#line 1196 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"
    {
      pdebug("TypeAnnotationValue ->");
      (yyval.id) = strdup("1");
    }
#line 2679 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"
    break;


#line 2683 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/build/compiler/cpp/thrift/thrifty.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1201 "/home/yoctouser/build-prod/tmp/work/riscv64-pine64-linux/thrift/0.16.0-r0/thrift-0.16.0/compiler/cpp/src/thrift/thrifty.yy"

